import json
from os import times


treeDepth = 8
boostedDepth = 4
nNodes = 2 ** treeDepth - 1 

graph = {
    'nodes': [{'id': i} for i in range(1, nNodes + 1)],
    'edges': []
}
for i in range(1, 2 ** (treeDepth - 1)):
    graph['edges'].append({'source': i, 'target': i * 2})
    graph['edges'].append({'source': i, 'target': i * 2 + 1}) 

with open('graph.json', 'w') as file:
    file.write(json.dumps(graph, indent=4)) 

boostedNodes = list(range(2 ** (boostedDepth - 1), 2 ** boostedDepth))

data = {
    'boostedNodes': boostedNodes,
    'sourceEvents': [
        {'timestamp': 0, 'id': 2, 'type': 'Ca'}, 
        {'timestamp': 0, 'id': 3, 'type': 'Cr'}
    ],
    'propagationEvents': []
}

def makePropEvents(node, timestamp, isPositive, isBoosted=False):
    if node * 2 > nNodes:
        return 
    
    if node in boostedNodes:
        isBoosted = True 

    for child in [node * 2, node * 2 + 1]:
        childIsBoosted = (child in boostedNodes) 
        edgeType = ('Ca+' if isBoosted or childIsBoosted else 'Ca') if isPositive else ('Cr-' if isBoosted else 'Cr')
        targetType = edgeType if isPositive else ('Cr-' if isBoosted or childIsBoosted else 'Cr') 

        data['propagationEvents'].append({
            'timestamp': timestamp,
            'source': node,
            'target': child,
            'edgeType': edgeType,
            'targetType': targetType
        })
        makePropEvents(child, timestamp + 1, isPositive, isBoosted or childIsBoosted) 

makePropEvents(2, 1, True)
makePropEvents(3, 1, False) 

with open('data.json', 'w') as file:
    file.write(json.dumps(data, indent=4))